import { Level, LevelNames } from ".";
import { Game } from "..";
import {
  Curry,
  FunctionApplication,
  LambdaFactory,
  LockedDoor,
  Player,
  Wall,
} from "../entities";

export class Tutorial extends Level {
  constructor() {
    super(LevelNames.Tutorial);
  }

  public init(game: Game): void {
    const entities = [
      new Player({ x: 2, y: 2 }),
      new Wall({ x: 10, y: 9 }),
      new Wall({ x: 10, y: 11 }),
      new Wall({ x: 11, y: 10 }),
      new Curry({ x: 10, y: 10 }),
      new LockedDoor({ x: 9, y: 10 }),
      new LambdaFactory({ x: 6, y: 3 }, "// TODO: Remove line\n(λ (x) . x)", 3),
      new FunctionApplication({ x: 6, y: 6 }, "(_INPUT key)"),
    ];

    entities.forEach((entity) => game.addEntity(entity));
  }
}
